<template>
    <section class="contenido">
        <base-card>
            <form @submit.prevent="subirForm">
                <div class="form-control" :class="{invalid: !email.esValido}">
                    <label for="email">Correo Electronico</label>
                    <input type="email" id="email" v-model.trim="email.val" @blur="limpiarValido('email')"/>
                    <p v-if="!email.esValido">Debe ingresar un email.</p>
                </div>
                <div class="form-control" :class="{invalid: !contrasena.esValido}">
                    <label for="contrasena">Contrasena</label>
                    <input type="password" id="contrasena" v-model.trim="contrasena.val" @blur="limpiarValido('contrasena')"/>
                    <p v-if="!contrasena.esValido">Debe ingresar una contrasena.</p>
                </div>
                <p v-if="!formEsValido">Porfavor ingrese un correo y contrasena validos</p>
                <div class="actions">
                    <base-button>{{submitButtonCaption}}</base-button>
                    <base-button type="button" mode="flat" @click="cambioAuthMode">{{switchModeButtonCaption}}</base-button>
                </div>
            </form>
        </base-card>
    </section>
</template>
<script>
export default {
    data() {
        return{
            email:{
                val:'',
                esValido:true
            },
            contrasena:{
                val:'',
                esValido:true
            },
            formEsValido:true,
            mode: 'login',
            logeado:'false'
        };
    },
    computed:{
        submitButtonCaption(){
            if(this.mode==='login'){
                return 'Iniciar Sesion';
            }else{
                return 'Registrarse';
            }
        },
        switchModeButtonCaption(){
            if(this.mode==='login'){
                return 'Registrarse';
            }else{
                return 'Iniciar Sesion';
            }
        }
    },
    methods:{
        limpiarValido(input){
            this[input].esValido=true;
            this.formEsValido=true;
        },
        subirForm(){
            this.validaForm();
            if(!this.formEsValido){
                return;
            }
        },
        cambioAuthMode(){
            if(this.mode === 'login'){
                this.formEsValido=true;
                this.mode = 'signup';
            }else{
                this.formEsValido=true;
                this.mode='login';
            }
        },
        validaForm(){
            this.formEsValido=true;
            if(this.email.val===''||!this.email.val.includes('@')){
                this.email.esValido=false;
                this.formEsValido=false;
            }
            if(this.contrasena.val===''||this.contrasena.val.length<8){
                this.contrasena.esValido=false;
                this.formEsValido=false;
            }
        },
    }
}
</script>
<style scoped>
.contenido{
    margin-top: 10rem;
}
form {
  margin: 1rem;
  padding: 1rem;
}

.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  margin-bottom: 0.5rem;
  display: block;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  border: 1px solid #ccc;
  padding: 0.15rem;
}

input:focus,
textarea:focus {
  border-color: #3d008d;
  background-color: #faf6ff;
  outline: none;
}

.errors {
  font-weight: bold;
  color: red;
}

.actions {
  margin-top: 1.5rem;
}
.invalid label{
  color: red;
}

.invalid h3{
  color: red;
}


.invalid input,
.invalid textarea {
  border: 1px solid red;
}
</style>